> ## Documentation Index
> Fetch the complete documentation index at: https://docs.support.onclarity.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List customers



## OpenAPI

````yaml /api-reference/support-openapi.json get /api/customer/list
openapi: 3.1.0
info:
  title: Clarity Support API
  version: '1.0'
  description: Tickets, customers, messages, the knowledge base, and webhooks.
servers:
  - url: https://back.leap.onclarity.com
security:
  - organizationApiKey: []
tags:
  - name: AI service
    description: >-
      Hand a customer conversation to your Clarity AI agent from your own app or
      backend.
  - name: Messages
    description: Reply to customers on their ticket's channel and add private notes.
  - name: Customers
    description: Create, update, and look up customers and their custom attributes.
  - name: Tickets
    description: >-
      Change a ticket's status, assignee, category, and tags, and list the
      values they take.
  - name: Knowledge base
    description: Manage the articles your AI agents answer from.
  - name: Webhooks
    description: Subscribe your endpoints to events in your organization.
paths:
  /api/customer/list:
    get:
      tags:
        - Customers
      summary: List customers
      operationId: ApiCustomerListListCustomers
      parameters:
        - name: search
          in: query
          schema:
            oneOf:
              - type: string
              - type: 'null'
          required: false
          deprecated: false
          allowEmptyValue: false
          allowReserved: false
        - name: channels
          in: query
          schema:
            oneOf:
              - items:
                  $ref: '#/components/schemas/ChannelType'
                type: array
              - type: 'null'
          required: false
          deprecated: false
          allowEmptyValue: false
          allowReserved: false
        - name: active
          in: query
          schema:
            oneOf:
              - type: boolean
              - type: 'null'
          required: false
          deprecated: false
          allowEmptyValue: false
          allowReserved: false
        - name: sort_by
          in: query
          schema:
            oneOf:
              - type: string
              - type: 'null'
          required: false
          deprecated: false
          allowEmptyValue: false
          allowReserved: false
        - name: tags
          in: query
          schema:
            oneOf:
              - items:
                  type: integer
                type: array
              - type: 'null'
          required: false
          deprecated: false
          allowEmptyValue: false
          allowReserved: false
        - name: custom_attributes
          in: query
          schema:
            oneOf:
              - items:
                  type: string
                type: array
              - type: 'null'
          required: false
          deprecated: false
          allowEmptyValue: false
          allowReserved: false
        - name: has_open_suggestion
          in: query
          schema:
            oneOf:
              - type: boolean
              - type: 'null'
          required: false
          deprecated: false
          allowEmptyValue: false
          allowReserved: false
        - name: missing_email
          in: query
          schema:
            oneOf:
              - type: boolean
              - type: 'null'
          required: false
          deprecated: false
          allowEmptyValue: false
          allowReserved: false
        - name: missing_phone
          in: query
          schema:
            oneOf:
              - type: boolean
              - type: 'null'
          required: false
          deprecated: false
          allowEmptyValue: false
          allowReserved: false
        - name: last_interaction_days
          in: query
          schema:
            oneOf:
              - type: integer
              - type: 'null'
          required: false
          deprecated: false
          allowEmptyValue: false
          allowReserved: false
        - name: limit
          in: query
          schema:
            type: integer
            default: 50
          required: false
          deprecated: false
          allowEmptyValue: false
          allowReserved: false
        - name: offset
          in: query
          schema:
            oneOf:
              - type: integer
              - type: 'null'
          required: false
          deprecated: false
          allowEmptyValue: false
          allowReserved: false
      responses:
        '200':
          description: Request fulfilled, document follows
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CustomerListPayload'
        '400':
          description: Bad request syntax or unsupported method
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/KTSErrorResponse'
        '500':
          description: Server got itself in trouble
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/KTSErrorResponse'
      deprecated: false
components:
  schemas:
    ChannelType:
      type: string
      enum:
        - whatsapp
        - android_sdk
        - ios_sdk
        - web
        - voice
        - social
        - x
        - email
        - instagram
        - linkedin
      title: ChannelType
      description: Channel type (web, android_sdk, ios_sdk, whatsapp)
    CustomerListPayload:
      properties:
        list:
          items:
            $ref: '#/components/schemas/Customer'
          type: array
        total:
          type: integer
      type: object
      required:
        - list
        - total
      title: CustomerListPayload
    KTSErrorResponse:
      properties:
        status:
          type: string
          default: error
        code:
          type: string
        message:
          oneOf:
            - type: string
            - type: 'null'
        extra:
          oneOf:
            - additionalProperties: {}
              type: object
            - items: {}
              type: array
            - type: 'null'
      type: object
      required:
        - code
      title: KTSErrorResponse
    Customer:
      properties:
        id:
          type: integer
        first_name:
          type: string
        last_name:
          oneOf:
            - type: string
            - type: 'null'
        avatar_url:
          oneOf:
            - type: string
            - type: 'null'
        organization_id:
          type: integer
        attributes:
          items:
            $ref: '#/components/schemas/CustomerAttribute'
          type: array
        tags:
          oneOf:
            - items:
                $ref: '#/components/schemas/Tag'
              type: array
            - type: 'null'
        custom_attributes:
          additionalProperties: {}
          type: object
          default: {}
        gender:
          oneOf:
            - type: string
            - type: 'null'
        gender_source:
          oneOf:
            - type: string
            - type: 'null'
        merged_into_id:
          oneOf:
            - type: integer
            - type: 'null'
        has_open_suggestion:
          type: boolean
          default: false
        channels:
          items:
            $ref: '#/components/schemas/ChannelType'
          type: array
      type: object
      required:
        - attributes
        - first_name
        - id
        - organization_id
      title: Customer
    CustomerAttribute:
      properties:
        key:
          type: string
        value:
          oneOf:
            - type: string
            - items:
                oneOf:
                  - type: string
                  - type: 'null'
              type: array
            - type: 'null'
      type: object
      required:
        - key
      title: CustomerAttribute
    Tag:
      properties:
        id:
          type: integer
        name:
          type: string
        description:
          oneOf:
            - type: string
            - type: 'null'
        color:
          type: string
      type: object
      required:
        - color
        - id
        - name
      title: Tag
  securitySchemes:
    organizationApiKey:
      type: http
      scheme: bearer
      description: >-
        Your organization API key (it starts with `anek_org_`). The same key
        works on the Voice API and the Support API. See
        [Authentication](/authentication).

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.